%Miscelaneous functions not used by EEGLAB graphic interface (miscfunc folder):
%  <a href="matlab:helpwin abspeak">abspeak</a>              - Find peak amps/latencies in each row of a single-epoch data matrix...
%  <a href="matlab:helpwin arrow">arrow</a>                - Draw a line with an arrowhead.
%  <a href="matlab:helpwin averef">averef</a>               - Convert common-reference EEG data to average reference...
%  <a href="matlab:helpwin caliper">caliper</a>              - Measure a set of spatial components of a given data epoch relative to...
%  <a href="matlab:helpwin chanproj">chanproj</a>             - Make a detailed plot of data returned from plotproj()...
%  <a href="matlab:helpwin compdsp">compdsp</a>              - Display standard info figures for a data decomposition...
%  <a href="matlab:helpwin compheads">compheads</a>            - Plot multiple topoplot() maps of ICA component topographies...
%  <a href="matlab:helpwin compile_eeglab">compile_eeglab</a>       - Platform compiling script...
%  <a href="matlab:helpwin compmap">compmap</a>              - Plot multiple topoplot() maps of ICA component topographies...
%  <a href="matlab:helpwin compplot">compplot</a>             - Plot a data epoch and maps its scalp topography at a given time...
%  <a href="matlab:helpwin compsort">compsort</a>             - Reorder ICA components, first largest to smallest by the size...
%  <a href="matlab:helpwin convolve">convolve</a>             - Convolve two matrices (normalize by the sum of convolved...
%  <a href="matlab:helpwin corrimage">corrimage</a>            - Compute correlation image between an event and amplitude...
%  <a href="matlab:helpwin covary">covary</a>               - For vectors, covary(X) returns the variance of X.
%  <a href="matlab:helpwin crossfold">crossfold</a>            - Returns estimates and plot of event-related coherence (ERC) changes...
%  <a href="matlab:helpwin crossfreq">crossfreq</a>            - Compute cross-frequency coherences. Power of first input...
%  <a href="matlab:helpwin datlim">datlim</a>               - Return min and max of a matrix...
%  <a href="matlab:helpwin del2map">del2map</a>              - Compute the discrete laplacian of an EEG distribution.
%  <a href="matlab:helpwin dendhier">dendhier</a>             - DENDHIER: Recursive algorithm to find links and distance coordinates on a...
%  <a href="matlab:helpwin dendplot">dendplot</a>             - DENDPLOT: Plots a dendrogram given a topology matrix.
%  <a href="matlab:helpwin difftopo">difftopo</a>             - Compute and plot component decomposition for the difference ERP...
%  <a href="matlab:helpwin dprime">dprime</a>               - Signal-detection theory sensitivity measure.
%  <a href="matlab:helpwin eeg_ms2f">eeg_ms2f</a>             - Convert epoch latency in ms to nearest epoch frame number...
%  <a href="matlab:helpwin eeg_regepochs">eeg_regepochs</a>        - Convert a continuous dataset into consecutive epochs of...
%  <a href="matlab:helpwin eeg_time2prev">eeg_time2prev</a>        - Returns a vector giving, for each event of specified ("target") type(s),...
%  <a href="matlab:helpwin eegdraw">eegdraw</a>              - Subroutine used by eegplotold() to plot data.
%  <a href="matlab:helpwin eegdrawg">eegdrawg</a>             - Subroutine used by eegplotgold() to plot data.
%  <a href="matlab:helpwin eegmovie">eegmovie</a>             - Compile and view a Matlab movie.
%  <a href="matlab:helpwin eegplotgold">eegplotgold</a>          - Display EEG data in a clinical format...
%  <a href="matlab:helpwin eegplotold">eegplotold</a>           - Display data in a horizontal scrolling fashion...
%  <a href="matlab:helpwin eegplotsold">eegplotsold</a>          - Display data in a clinical format without scrolling...
%  <a href="matlab:helpwin envproj">envproj</a>              - Plot envelopes of projections of selected ICA component...
%  <a href="matlab:helpwin erpregout">erpregout</a>            - Regress out the ERP from the data...
%  <a href="matlab:helpwin erpregoutfunc">erpregoutfunc</a>        - Sub function of erpregout() used to regress...
%  <a href="matlab:helpwin eucl">eucl</a>                 - EUCL: Calculates the euclidean distances among a set of points, or between a...
%  <a href="matlab:helpwin fastregress">fastregress</a>          - Perform fast regression and return p-value...
%  <a href="matlab:helpwin fillcurves">fillcurves</a>           - Fill the space between 2 curves...
%  <a href="matlab:helpwin gabor2d">gabor2d</a>              - Generate a two-dimensional gabor matrice.
%  <a href="matlab:helpwin gauss">gauss</a>                - Return a smooth Gaussian window...
%  <a href="matlab:helpwin gauss2d">gauss2d</a>              - Generate a 2-dimensional gaussian matrix...
%  <a href="matlab:helpwin gauss3d">gauss3d</a>              - Generate a 3-dimensional gaussian matrix...
%  <a href="matlab:helpwin getallmenus">getallmenus</a>          - Get all submenus of a window or a menu and return...
%  <a href="matlab:helpwin getipsph">getipsph</a>             - Compute "in place" (m by n) sphering or quasi-sphering matrix for an (n by t)...
%  <a href="matlab:helpwin gradmap">gradmap</a>              - Compute the gradient of an EEG spatial distribution.
%  <a href="matlab:helpwin gradplot">gradplot</a>             - Compute the gradient of EEG scalp map(s) on a square grid...
%  <a href="matlab:helpwin headmovie">headmovie</a>            - Record a Matlab movie of scalp data.
%  <a href="matlab:helpwin help2html2">help2html2</a>           - Convert a Matlab m-file help-message header into an .html help file...
%  <a href="matlab:helpwin helpforexe">helpforexe</a>           - Write help files for exe version...
%  <a href="matlab:helpwin hist2">hist2</a>                - Draw superimposed histograms...
%  <a href="matlab:helpwin hungarian">hungarian</a>            - Solve the assignment problem using the Hungarian method.
%  <a href="matlab:helpwin icademo">icademo</a>              - A sample ICA analysis script using the ICA/ERP package...
%  <a href="matlab:helpwin imagescloglog">imagescloglog</a>        - Make an imagesc(0) plot with log y-axis and...
%  <a href="matlab:helpwin imagesclogy">imagesclogy</a>          - Make an imagesc(0) plot with log y-axis values (ala semilogy())...
%  <a href="matlab:helpwin iscellnumeric">iscellnumeric</a>        - Return 1 if all elements of cell array are numeric...
%  <a href="matlab:helpwin kmeans_st">kmeans_st</a>            - Means clustering of n points into k clusters so that the...
%  <a href="matlab:helpwin laplac2d">laplac2d</a>             - Generate a 2 dimensional gaussian matrice...
%  <a href="matlab:helpwin lapplot">lapplot</a>              - Compute the discrete laplacian of EEG scalp distribution(s)...
%  <a href="matlab:helpwin loadelec">loadelec</a>             - Load electrode names file for eegplot()...
%  <a href="matlab:helpwin loc_subsets">loc_subsets</a>          - Separate channels into maximally evenly-spaced subsets.
%  <a href="matlab:helpwin logimagesc">logimagesc</a>           - Make an imagesc(0) plot with log y-axis values (ala semilogy())...
%  <a href="matlab:helpwin loglike">loglike</a>              - Log likehood function to estimate dependence between components...
%  <a href="matlab:helpwin logspec">logspec</a>              - Plot mean log power spectra of submitted data on loglog scale...
%  <a href="matlab:helpwin make_timewarp">make_timewarp</a>        - Select a subset of epochs containing a given event sequence, and return...
%  <a href="matlab:helpwin makeelec">makeelec</a>             - Subroutine to make electrode file in eegplot()...
%  <a href="matlab:helpwin makehelpfiles">makehelpfiles</a>        - Generate function help pages...
%  <a href="matlab:helpwin makehtml">makehtml</a>             - Generate .html function-index page and function help pages...
%  <a href="matlab:helpwin mapcorr">mapcorr</a>              - Find matching rows in two matrices and their corrs.
%  <a href="matlab:helpwin matcorr">matcorr</a>              - Find matching rows in two matrices and their corrs.
%  <a href="matlab:helpwin matperm">matperm</a>              - Transpose and sign rows of x to match y (run after matcorr() )...
%  <a href="matlab:helpwin means">means</a>                - MEANS:  Means, standard errors and variances.  For column vectors, means(x)...
%  <a href="matlab:helpwin nan_std">nan_std</a>              - Std, not considering NaN values...
%  <a href="matlab:helpwin numdim">numdim</a>               - Estimate a lower bound on the (minimum) number of discrete sources...
%  <a href="matlab:helpwin pcexpand">pcexpand</a>             - Expand data using Principal Component Analysis (PCA)...
%  <a href="matlab:helpwin pcsquash">pcsquash</a>             - Compress data using Principal Component Analysis (PCA)...
%  <a href="matlab:helpwin perminv">perminv</a>              - Returns the inverse permutation vector...
%  <a href="matlab:helpwin plotproj">plotproj</a>             - Plot projections of one or more ICA components along with...
%  <a href="matlab:helpwin promax">promax</a>               - Perform Promax oblique rotation after orthogonal Varimax...
%  <a href="matlab:helpwin qrtimax">qrtimax</a>              - Perform Quartimax rotation of rows of a data matrix.
%  <a href="matlab:helpwin read_rdf">read_rdf</a>             - Read RDF-formatted EEG files.
%  <a href="matlab:helpwin readlocsold">readlocsold</a>          - Read electrode locations file in style of topoplot() or headplot().
%  <a href="matlab:helpwin rmart">rmart</a>                - Remove eye artifacts from EEG data using regression with...
%  <a href="matlab:helpwin rmsave">rmsave</a>               - Return the RMS in each channel, epoch...
%  <a href="matlab:helpwin runicalowmem">runicalowmem</a>         - Perform Independent Component Analysis (ICA) decomposition...
%  <a href="matlab:helpwin runicatest">runicatest</a>           - Perform Independent Component Analysis (ICA) decomposition...
%  <a href="matlab:helpwin runpca">runpca</a>               - Perform principal component analysis (PCA) using singular value...
%  <a href="matlab:helpwin runpca2">runpca2</a>              - Perform principal component analysis (PCA) using singular value...
%  <a href="matlab:helpwin scanfold">scanfold</a>             - Scan folder content...
%  <a href="matlab:helpwin seemovie">seemovie</a>             - See an EEG movie produced by eegmovie()...
%  <a href="matlab:helpwin setfont">setfont</a>              - Change all the fonts properties of a figure.
%  <a href="matlab:helpwin shortread">shortread</a>            - Read matrix from short file.
%  <a href="matlab:helpwin show_events">show_events</a>          - Display events in epochs. Events selected by...
%  <a href="matlab:helpwin testica">testica</a>              - Test the runica() function's ability to separate synthetic sources.
%  <a href="matlab:helpwin textgui">textgui</a>              - Make sliding vertical window. This window contain text...
%  <a href="matlab:helpwin tftopo">tftopo</a>               - Generate a figure showing a selected or representative image (e.g.,...
%  <a href="matlab:helpwin timefrq">timefrq</a>              - Progressive Power Spectral Density estimates on a single...
%  <a href="matlab:helpwin topoimage">topoimage</a>            - Plot concatenated multichannel time/frequency images...
%  <a href="matlab:helpwin tree">tree</a>                 - Make a hierarchical (tree-diagram) component plot. Use...
%  <a href="matlab:helpwin tutorial">tutorial</a>             - Bring up the ICA / electrophysiology toolbox tutorial...
%  <a href="matlab:helpwin uniqe_cell_string">uniqe_cell_string</a>    - Array containing only strings, ignores all...
%  <a href="matlab:helpwin uniquef">uniquef</a>              - UNIQUEF: Given a matrix containing group labels, returns a vector containing...
%  <a href="matlab:helpwin upgma">upgma</a>                - Group hierarchical cluster analysis of a distance...
%  <a href="matlab:helpwin varimax">varimax</a>              - Perform orthogonal Varimax rotation on rows of a data...
%  <a href="matlab:helpwin varsort">varsort</a>              - Reorder ICA components, largest to smallest, by...
%  <a href="matlab:helpwin vectdata">vectdata</a>             - Vector data interpolation with optional moving...
%  <a href="matlab:helpwin zica">zica</a>                 - Z-transform of ICA activations; useful for studying component SNR...
