% optFIR plugin
%
% Plugin for EEGlab to implement optimal FIR filter via Cook and Miller 
% Optimal Digital Filtering approach (with hamming option applied 
% when truncating filter to final filter order). See: 
%
% Cook, E.W., & Miller, G.A. (1992).  Digital Filtering: Background and tutorial for 
%   psychophysiologists. Psychophysiology, 3, 350-367
%
% Also allows comparison to EEGlab built in filters eegfilt and iirfilt.
%
% Requires Signal Processing Toolbox to be installed.  
%
%
% Version 0.9
%
% Written July, 2011, by John JB Allen jallen@u.arizona.edu
%
% See Also:  pop_optFIR, pop_optFIR_compare, optFIR.m, optFIR_compare, optFIR_design, FIR_filt, FIR_freq_rsps, IIR_freq_rsps

function pop_about_optFIR_compare

supergui('geomhoriz', { 1 1 1 1 1 1 1 1 1 1 1 1 1 1 [.7 .3 ]}, 'title', 'Optimal FIR plugin version 0.9', 'uilist', { ...
    { 'style', 'text', 'string', 'Optimal FIR Filtering Plugin:' 'fontweight' 'bold' }, ...
    { 'style', 'text', 'string', '     Implements Cook and Miller (1992) optimal FIR approach in EEGLAB.' }, ...
    { 'style', 'text', 'string', '     Provides comparison tool to:' }, ... 
    { 'style', 'text', 'string', '        Compare optimal FIR approach and EEGLAB Basic FIR and Short IIR' }, ...
    { 'style', 'text', 'string', '           filters in terms of transfer functions, time to filter, and correlations' }, ...
    { 'style', 'text', 'string', '           with the ideal transfer function.' }, ...
    { 'style', 'text', 'string', '        Preview two signals (unfiltered versus filtered, or two filtered versions)' }, ...
    { 'style', 'text', 'string', '           without altering any data.' }, ...
    { 'style', 'text', 'string', '' }, ...
    { 'style', 'text', 'string', 'Details:' 'fontweight' 'bold' }, ...
    { 'style', 'text', 'string', '    Author: John J.B. Allen' }, ...
    { 'style', 'text', 'string', '    Email: John.JB.Allen@Arizona.edu' }, ...
    { 'style', 'text', 'string', '    Downloads: www.psychofizz.org' }, ...
    { 'style', 'text', 'string', '' }, ...
    { 'style', 'text', 'string', '' }, ...
    { 'style', 'pushbutton' , 'string', 'Darn Right!', 'callback', 'close(gcbf);' } ...
    }) ;
